<template>
    <div class="m-5 content-grid content-grid--subpage content-grid--subpage-table">
        <!--<Breadcrumbs :title="t(`global.welcome`)" />-->

        <div style="margin-top:60px" class="content-grid__header">
            <h1>{{ t('global.welcome')}}</h1>
        </div>
        <Card :title="t('global.quickLinks')" class="card--row-content">
            <BtnLink :name="t('routes.cours.children.cours.add.name')"
                        :path="{ name: 'cours.children.cours.add' }" />

        </Card>

        <Card>
            <DataTable :headers="coursHeader"
                        :items="tableCours"
                        :search-value="searchValue"
                        @delete="deleteCours"
                       @click="handleRowClick"/>
        </Card>

    </div>
</template>

<script lang="ts" setup>
    import i18n from "@/i18n";
    import {useI18n} from "vue3-i18n";
    
    const {t} = useI18n()  
    import { computed, onMounted, ref } from "vue";
    import { useCoursService } from "@/inversify.config";
    import { notifyError, notifySuccess } from "@/notify";
    import Card from "@/components/layout/Card.vue";
    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import DataTable from "@/components/layout/DataTable.vue";
    import { Cours } from "@/types/entities/cours";
    import SearchInput from "@/components/layout/SearchInput.vue";
    import BtnLink from "@/components/layout/BtnLink.vue";
    import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";
    import { Member } from "../types";
    import { useMemberStore } from "@/stores/memberStore";
    import { useMemberService } from "@/inversify.config";
    import { Role } from "@/types";
    const memberStore = useMemberStore()
   
    const allCours = ref<Cours[]>([]);
    const coursService = useCoursService();
    const searchValue = ref("");
    const memberService = useMemberService();
    const tableCours = computed(() => {  
        console.log(memberStore.getMember);
        return allCours.value
            .map((x: Cours) => {
                return {
                    id: x.id,
                    code: x.code,
                    nomCours: x.nomCours,
                    actions: {
                        update: {
                            path: `/fr/cours/${x.id}/modifier`,
                            params: { id: x.id },
                        },                     
                        delete: true,
                        view: {
                            path: `/fr/cours/${x.id}/details`,
                            params: {
                                id: x.id,
                            },
                        },
                    },
                };
            })
            .sort((a: any, b: any) => {
                if (a.name < b.name) {
                    return -1;
                }
                if (a.name > b.name) {
                    return 1;
                }
                return 0;
            }) as unknown as Cours[];
    });
    
    onMounted(async () => {
        await loadAllCours();
    });

    const handleRowClick = (e: any) => {
        e.target.parentNode.getElementsByTagName('a')[0].click()
    }


    async function loadAllCours() {
       
      
        var members =  await memberService.getAllMembers();
        var userConncte = await memberService.getCurrentMember();
      
        const member = await members.find((x) => x.email === userConncte?.email);
        if (member != null && member.id != null) {
            let cours = await coursService.getAllCoursByMember(member.id);
            if (cours && cours.length > 0) {
                allCours.value = cours;
            }

        }
        //jUSTE JE VAIS VALIDER UN TRUC AVEC jp PUIS JE SUPPRIME LE COMMENTAIRE, MERCI


        //if (memberStore.hasRole(Role.Admin)) {
        //    cours = await coursService.getAllCours();
        //    if (cours && cours.length > 0) {
        //        allCours.value = cours;
        //    }
        //} else {
        //    if (member != null && member.id != null) {
        //        cours = await coursService.getAllCoursByMember(member.id);
        //        if (cours && cours.length > 0) {
        //            allCours.value = cours;
        //        }

        //    }
        //}
         
          
             
            
    }
    
    async function deleteCours(cours: Cours) {
        if (cours.id == null) return;
        let confirmation = confirm(t("validation.cours.delete.confirmation"));
        if (!confirmation) return;
        let response = await coursService.deleteCours(cours.id);
        if (response.succeeded) {
            allCours.value = allCours.value.filter((x) => x.id !== cours.id);
            notifySuccess(t("validation.cours.delete.success"));
        } else {
            let errorMessages = response.getErrorMessages(
                "validation.cours.delete.confirmation",
                "validation.cours.delete.errorOccured"
            );
            notifyError(errorMessages[0]);
        }
    }

    const coursHeader = [
        {
            text: "Code",
            value: "code",
            sortable: true,
            width: 300,
        },
        {
            text: "Nom Cours",
            value: "nomCours",
            sortable: true,
            width: 150,
        },
        {
            text: "",
            value: "actions",
            width: 75,
        },
    ];
</script>
<style scoped>
    .container{
        margin: 0 auto;
        width: 75%;
    }
</style>

    